###############################################################################
# Main CMake file for the agrid project
###############################################################################
# @author Michele Lora
#

cmake_minimum_required (VERSION 2.4)

project (agrid)

set(CMAKE_BUILD_TYPE DEBUG)
set(CMAKE_C_FLAGS_DEBUG "-O0 -Wall -Wextra -pedantic -ggdb")
set(CMAKE_C_FLAGS_RELEASE "-O3")
set(CMAKE_CXX_FLAGS_DEBUG "-O0 -Wall -Wextra -pedantic -ggdb")
set(CMAKE_CXX_FLAGS_RELEASE "-O3")

set( CMAKE_EXPORT_COMPILE_COMMANDS ON )

# Set a default build type if none was specified
set(default_build_type "Release")
if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
    set(default_build_type "Debug")
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
    set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
            STRING "Choose the type of build." FORCE)
# Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
            "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

set( DEFAULT_INSTALL_LOCATION chase-${CMAKE_BUILD_TYPE} )

option(ENABLE_INSTALL_PREFIX "Install build targets to system (path given by '-DCMAKE_INSTALL_PREFIX' or '${CMAKE_INSTALL_PREFIX}' if not specified)." ON)
if ( ENABLE_INSTALL_PREFIX )
        set (CMAKE_INSTALL_PREFIX ${DEFAULT_INSTALL_LOCATION} CACHE PATH "Installation root")
else()
        set (CMAKE_INSTALL_PREFIX ${DEFAULT_INSTALL_LOCATION} CACHE PATH "Installation root" FORCE)
endif()

set( srcs
    ${PROJECT_SOURCE_DIR}/src/main.cc
    ${PROJECT_SOURCE_DIR}/src/utilities.cc
    ${PROJECT_SOURCE_DIR}/src/problem.cc
    ${PROJECT_SOURCE_DIR}/src/nusmv_printer.cc
    ${PROJECT_SOURCE_DIR}/src/smt_printer.cc
    ${PROJECT_SOURCE_DIR}/src/standard_sensor.cc
    ${PROJECT_SOURCE_DIR}/src/proximity_sensor.cc
    ${PROJECT_SOURCE_DIR}/src/radar_sensor.cc
    ${PROJECT_SOURCE_DIR}/src/sns_actuation_imperfections.cc
    ${PROJECT_SOURCE_DIR}/src/smt_software_skeleton.cc
    ${PROJECT_SOURCE_DIR}/src/fsm/variable.cc
    ${PROJECT_SOURCE_DIR}/src/fsm/mealy_machine.cc
    ${PROJECT_SOURCE_DIR}/src/json_parser.cc
   ) 

include_directories(
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/third_party/nlohmann
    )

add_executable(agrid ${srcs})

set_property(TARGET agrid PROPERTY CXX_STANDARD 11)
set_property(TARGET agrid PROPERTY OUTPUT_NAME agrid)


install(TARGETS agrid DESTINATION bin)
